System.register(["@angular/core"], function (exports_1, context_1) {
    "use strict";
    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __metadata = (this && this.__metadata) || function (k, v) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
    };
    var __moduleName = context_1 && context_1.id;
    var core_1, core_2, GridComponent;
    return {
        setters: [
            function (core_1_1) {
                core_1 = core_1_1;
                core_2 = core_1_1;
            }
        ],
        execute: function () {
            GridComponent = (function () {
                function GridComponent() {
                    ej.Menu.prototype._subMenuPos = function (element, direction) {
                        var pos = $(element).offset();
                        var subMenuLeft, subMenuRight;
                        var posLeft = pos.left;
                        var subMenu = $('ul:first', element);
                        var menuWidth = $(element).outerWidth();
                        if (pos == null || pos == undefined)
                            return false;
                        var submenuWidth = subMenu.outerWidth() + 1; // +1 for the space between menu and submenu
                        var left = this.model.container ? $(this.model.container).width() + $(document).scrollLeft() : document.documentElement.clientWidth + $(document).scrollLeft();
                        if (this.model.menuType == "normalmenu") {
                            if ($(element.parentNode).is(this.element)) {
                                if (this.model.orientation == "horizontal") {
                                    subMenu.css("top", (($(element).outerHeight() - $(element).find("ul").outerHeight()) - $(element).outerHeight()) + "px");
                                    if (!this.model.enableRTL) {
                                        subMenuLeft = (left < (posLeft + submenuWidth)) ? ((posLeft + submenuWidth) - left) : 1;
                                        subMenu.css("left", (subMenuLeft * (-1)) + "px");
                                    }
                                    else {
                                        subMenuRight = (((posLeft + menuWidth) - submenuWidth) < 0) ? ((posLeft + menuWidth) - submenuWidth) : 1;
                                        subMenu.css({ "left": "auto", "right": subMenuRight + "px" });
                                    }
                                }
                                else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth && posLeft > submenuWidth))
                                    subMenu.css("left", -(submenuWidth + 4) + "px");
                                else {
                                    subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                                }
                            }
                            else if ((direction == "left" && posLeft > submenuWidth) || (direction == "right" && left <= pos.left + menuWidth + submenuWidth && posLeft > submenuWidth)) {
                                subMenu.css("left", -(submenuWidth + 4) + "px");
                            }
                            else {
                                subMenu.css("left", ($(element).outerWidth() + 4) + "px");
                                var submenuHeight = subMenu.outerHeight();
                                var winHeight = $(window).height();
                                var submenuTop = (winHeight - (pos.top - $(window).scrollTop()));
                                if (winHeight < submenuHeight) {
                                    var menuPos = pos.top - $(window).scrollTop();
                                    subMenu.css("top", -(menuPos) + 4 + "px");
                                }
                                else if (submenuTop < submenuHeight) {
                                    var menuPos = submenuTop - submenuHeight;
                                    subMenu.css("top", menuPos - 2 + "px");
                                }
                                else
                                    subMenu.css("top", "");
                            }
                        }
                        else {
                            left -= (pos.left + (2 * submenuWidth) + 4);
                            if (left < 0) {
                                var menuLeftPos = (submenuWidth == null) ? "-206.5px" : "-" + (submenuWidth + 5) + "px";
                                subMenu.css("left", menuLeftPos);
                            }
                            else {
                                if (subMenu.parent('li.e-list').parent('ul').width() && direction == "right") {
                                    subMenu.css("left", (subMenu.parent('li.e-list').parent('ul').width() + 4) + "px");
                                }
                                else if (pos.left > submenuWidth)
                                    subMenu.css("left", -(submenuWidth + 4) + "px");
                            }
                            var submenuHeight = subMenu.outerHeight();
                            if ((pos.top + submenuHeight > $(window).height())) {
                                var top = -(submenuHeight) + $(element).outerHeight();
                                if (submenuHeight > (pos.top + ($(element).outerHeight() / 2))) {
                                    subMenu.css("top", -(submenuHeight / 2) + "px");
                                }
                                else
                                    subMenu.css("top", top + "px");
                            }
                            else
                                subMenu.css("top", "0px");
                        }
                    },
                        this.localdata = [
                            { id: 1, text: 'Languages', parentId: null },
                            { id: 2, text: 'Country', parentId: null },
                            { id: 11, parentId: 1, text: 'Latvian' },
                            { id: 12, parentId: 1, text: 'English' },
                            { id: 13, parentId: 1, text: 'Estonian' },
                            { id: 14, parentId: 1, text: 'Workflow' },
                            { id: 15, parentId: 2, text: 'India' },
                            { id: 16, parentId: 2, text: 'Japan' },
                        ];
                    this.localfieldsvalues = { dataSource: this.localdata, parentId: 'parentId', id: 'id', text: 'text' };
                }
                GridComponent = __decorate([
                    core_1.Component({
                        selector: 'ej-app',
                        templateUrl: 'src/grid/grid.component.html',
                        styleUrls: ['src/menu.component.css'],
                        encapsulation: core_2.ViewEncapsulation.None,
                    }),
                    __metadata("design:paramtypes", [])
                ], GridComponent);
                return GridComponent;
            }());
            exports_1("GridComponent", GridComponent);
        }
    };
});
//# sourceMappingURL=grid.component.js.map